DO I=0, N-1 
AB(15,8*I+1) = 2.E+0_DP*y(I+1)-2.E+0_DP*y(I)
AB(15,8*I+2) = 3.333333333333333E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(15,8*I+3) = 2.E-1_DP*(2.E+0_DP*y(I+1)-2.E+0_DP*y(I))
AB(15,8*I+4) = 1.4285714285714285E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(15,8*I+5) = 1.1111111111111112E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(15,8*I+6) = 9.090909090909092E-2_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
ENDDO 
DO I=1, N 

IF (8*I-15>0 ) AB(17,8*I-9) = 1.E+0_DP
IF ( N2>=8*I-1) AB(9,8*I-1) = -1.E+0_DP
IF ( N2>=8*I-1) AB(21,8*I-7) = -1.E+0_DP
IF ( N2>=8*I-1) AB(13,8*I+1) = 1.E+0_DP

IF (8*I-15>0 ) AB(18,8*I-9) = -1.E+0_DP
IF ( N2>=8*I-1) AB(10,8*I-1) = -1.E+0_DP
IF ( N2>=8*I-1) AB(20,8*I-6) = -1.E+0_DP
IF ( N2>=8*I-1) AB(12,8*I+2) = -1.E+0_DP
IF (8*I-14>0 ) AB(17,8*I-8) = (2.E+0_DP*y(I-1)-2.E&
	&+0_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=8*I) AB(9,8*I) = -2.E+0_DP
IF ( N2>=8*I) AB(21,8*I-6) = -2.E+0_DP
IF ( N2>=8*I) AB(13,8*I+2) = (2.E+0_DP*y(I)-2.E+0_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))

IF (8*I-15>0 ) AB(19,8*I-9) = 1.E+0_DP
IF ( N2>=8*I-1) AB(11,8*I-1) = -1.E+0_DP
IF ( N2>=8*I-1) AB(19,8*I-5) = -1.E+0_DP
IF ( N2>=8*I-1) AB(11,8*I+3) = 1.E+0_DP
IF (8*I-14>0 ) AB(18,8*I-8) = (6.E+0_DP*y(I-2)-6.E&
	&+0_DP*y(I-1))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=8*I) AB(10,8*I) = -6.E+0_DP
IF ( N2>=8*I) AB(20,8*I-5) = -6.E+0_DP
IF ( N2>=8*I) AB(12,8*I+3) = (6.E+0_DP*y(I-1)-6.E+0_DP&
	&*y(I))/(y(I+1)-1.E+0_DP*y(I))

IF (8*I-15>0 ) AB(20,8*I-9) = -1.E+0_DP
IF ( N2>=8*I-1) AB(12,8*I-1) = -1.E+0_DP
IF ( N2>=8*I-1) AB(18,8*I-4) = -1.E+0_DP
IF ( N2>=8*I-1) AB(10,8*I+4) = -1.E+0_DP
IF (8*I-14>0 ) AB(19,8*I-8) = (1.2E+1_DP*y(I-1)-1.2E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=8*I) AB(11,8*I) = -1.2E+1_DP
IF ( N2>=8*I) AB(19,8*I-4) = -1.2E+1_DP
IF ( N2>=8*I) AB(11,8*I+4) = (1.2E+1_DP*y(I)-1.2E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))

IF (8*I-15>0 ) AB(21,8*I-9) = 1.E+0_DP
IF ( N2>=8*I-1) AB(13,8*I-1) = -1.E+0_DP
IF ( N2>=8*I-1) AB(17,8*I-3) = -1.E+0_DP
IF ( N2>=8*I-1) AB(9,8*I+5) = 1.E+0_DP
IF (8*I-14>0 ) AB(20,8*I-8) = (2.E+1_DP*y(I-2)-2.E&
	&+1_DP*y(I-1))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=8*I) AB(12,8*I) = -2.E+1_DP
IF ( N2>=8*I) AB(18,8*I-3) = -2.E+1_DP
IF ( N2>=8*I) AB(10,8*I+5) = (2.E+1_DP*y(I-1)-2.E+1_DP&
	&*y(I))/(y(I+1)-1.E+0_DP*y(I))

IF (8*I-15>0 ) AB(22,8*I-9) = -1.E+0_DP
IF ( N2>=8*I-1) AB(14,8*I-1) = -1.E+0_DP
IF ( N2>=8*I-1) AB(16,8*I-2) = -1.E+0_DP
IF ( N2>=8*I-1) AB(8,8*I+6) = -1.E+0_DP
IF (8*I-14>0 ) AB(21,8*I-8) = (3.E+1_DP*y(I-1)-3.E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=8*I) AB(13,8*I) = -3.E+1_DP
IF ( N2>=8*I) AB(17,8*I-2) = -3.E+1_DP
IF ( N2>=8*I) AB(9,8*I+6) = (3.E+1_DP*y(I)-3.E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))
ENDDO 
